/*
 * @Author: Badguy
 * @Date: 2022-04-27 15:54:38
 * @LastEditTime: 2022-04-28 09:51:22
 * @LastEditors: your name
 * @Description: 服务相关数据查询
 * have a nice day!
 */

import { Query } from '@/api/dataIntegration'

const queryMap = {
  protocol: 1,
  machine: 2,
  service: 3,
  source: 4,
  sourceInfo: 5,
  sourceAndService: 6,
  outputTarget: 7,
  outputTargetDetail: 8,
  outputTargetAndService: 9,
  machineAndService: 10,
  serviceDetail: 11,
  machineByServiceID: 12,
  sourceByServiceID: 13,
  targetByServiceID: 14,
  targetDetailByID: 15,
  sourceDetailByID: 16,
  targetByID: 17,
  sourceByID: 18,
  processByServiceID: 19,
  outputTargetByServiceID: 20
}

export default {
  data() {
    return {}
  },
  mounted() {
    this.serviceID && this.queryAll(this.serviceID)
  },
  methods: {
    myQuery(queryID, serviceID) {
      const params = {
        id: queryID,
        dataContent: []
      }
      serviceID ?? params.dataContent.push(serviceID)
      return new Promise((resolve, reject) => {
        Query(params)
          .then(result => {
            if (Number(result.code) === 0) {
              resolve(result.returnData)
            } else {
              reject(result.message)
            }
          })
          .catch(error => {
            console.log('错误', error)
          })
      })
    },
    queryService(serviceID) {
      return this.myQuery(queryMap.serviceDetail, serviceID)
    },
    queryMachineListByServiceId(serviceID) {
      return this.myQuery(queryMap.machineByServiceID, serviceID)
    },
    queryProtocolList() {
      return this.myQuery(queryMap.protocol)
    },
    querySourceListByServiceId(serviceID) {
      return this.myQuery(queryMap.sourceByServiceID, serviceID)
    },
    queryOutputTargetListByServiceId(serviceID) {
      return this.myQuery(queryMap.outputTargetByServiceID, serviceID)
    },
    queryAll(serviceID) {
      Promise.all([
        this.queryService(serviceID),
        this.queryMachineListByServiceId(serviceID),
        this.queryProtocolList(),
        this.querySourceListByServiceId(serviceID),
        this.queryOutputTargetListByServiceId(serviceID)
      ]).then(results => {
        // const [serviceInfo, machineList, sourceList, targetList] = results
        console.log(results)
      }).catch(error => {
        this.$message.error(error ?? '失败')
      })
    }
  }
}
